PIDOF(8)

NOME
pidof - encontra o ID de processo de um programa a correr

RESUMO
pidof [-s] [-c] [-n] [-x] [-z] [-o omitpid[,omitpid...]] [-o omitpid[,omitpid...]...] [-d sep] programa [programa...]

DESCRIÇÃO
O pidof encontra os id's de processos (PIDs) dos programas nomeados. Escreve esses id's na saída standard. Este programa é usado em alguns sistemas em scripts de mudança de nível de execução, especialmente quando o sistema tem uma estrutura rc tipo System-V. Nesse caso estes scripts estão localizados em /etc/rc?.d, onde ? é o runlevel. Se o sistema tem um programa start-stop-daemon(8) deve ser esse o usado em vez disto.

OPÇÕES

-s  Single shot - isto instruí o programa a apenas retornar um pid.

-c  Apenas retorna PIDs de processos que estão a correr no mesmo directório raiz. Esta opção é ignorada para utilizadores não-root, pois seria incapaz de verificar o directório raiz actual dos processos que não possui.

-n  Evita chamar a função de sistema stat(2) em todos os binários que estão localizados em sistemas de ficheiros baseados em rede como NFS. Em vez de usar esta opção a variável PIDOF_NETFS pode ser definida e exportada.

-q  Não mostra os PIDs correspondentes na saída standard. Simplesmente termina com um estado de verdadeiro ou falso para indicar se foi encontrado um PID correspondente.

-x  Scripts too - isto faz o programa também retornar id's de processos de shells que correm nos strings nomeados.

-z  Tenta detectar processos que estão presos em estado zombie (Z). Normalmente estes processos são saltados pois tentar lidar com eles causa ao pidof ou a ferramentas relacionadas ficarem paradas. Nota: No passado o pidof iria ignorar processos no estado ininterrupto (D), a menos que a bandeira -z fosse especificada. Este não é mais o caso. O program pidof irá encontrar e reportar processos no estado D quer -z seja especificada ou não.

-d sep
    Diz ao pidof para usar sep como um separador de resultados se for mostrado mais do que um PID. O separador predefinido é um espaço.

-o omitpid
    Diz ao pidof para omitir processos com esse id de processo. O pid especial %PPID pode ser usado para nomear o processo pai do programa pidof, por outras palavras, a shell ou script de shell que o chama.

ESTADO DE SAÍDA

0   Pelo menos um programa foi encontrado com o nome requisitado.

1   Nenhum programa foi encontrado com o nome requisitado.

NOTAS
pidof é na realidade o mesmo programa que killall5(8); o programa comporta-se de acordo com o nome pelo qual é chamado.

Quando o pidof é invocado com um nome de caminho completo para o programa que deve encontrar o pid, é razoavelmente seguro. Caso contrário, é possível que retorne PIDs de programas a correr que tenham o mesmo nome que o programa que procura mas sejam na realidade outros programas. Note que o nome executável dos processos que correm é calculado com readlink(2), assim os links simbólicos para executáveis também podem corresponder.

Os processos zombie ou processos em disco adormecido (estados Z e D, respetivamente) são ignorados, pois as tentativas de aceder às estatísticas destes irá algumas vezes falhar. A bandeira -z (veja em cima) diz ao pidof para tentar detectar estes processos adormecidos e zombie, com o risco de falhar ou ficar pendurado.

VEJA TAMBÉM
shutdown(8), init(8), halt(8), reboot(8), killall5(8)

AUTOR
Miquel van Smoorenburg (miquels@cistron.nl)